# -*- coding:Utf-8 -*-
# hit_stat V1.210p by DoCky (27/05/09)

import es, vecmath, langlib, popuplib

hs_info = es.AddonInfo()
hs_info.version = "1.210p"
hs_info.author = "DoCky"
hs_info.name = "hit_stat"
hs_info.url = "http://addons.eventscripts.com/addons/user/11751"

version = es.ServerVar(hs_info.name, hs_info.version, "By DoCky -")
version.set(hs_info.version)
version.makepublic()

stats = {}
popup = set()
settings = {}


class VictimInfo(object):
    """ victim info """
    def __init__(self, name):
        self._name = name
        self._damage = 0
        self._hit = 0
        self._killer = ""
        self._distance = 0
        self._headshot = 0
        self._weapon = ""
        self._zone = ([0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0])

    def hurt(self, damage, zone):
        self._damage += damage
        self._hit += 1
        self._zone[zone][0] += damage
        self._zone[zone][1] += 1

    def death(self, name, weapon, headshot, distance):
        self._weapon = weapon
        self._headshot = headshot
        self._distance = distance

class AttackerInfo(object):
    """ attacker info """
    def __init__(self, name):
        self._name = name
        self._damage = 0
        self._hit = 0
        self._zone = ([0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0], [0, 0])

    def hurt(self, damage, zone):
        self._damage += damage
        self._hit += 1
        self._zone[zone][0] += damage
        self._zone[zone][1] += 1

class PlayerStat(object):
    """ player statistic """
    def __init__(self, name):
        self._name = name
        self._attacker = {}
        self._victim = {}
        self._killed = []
        self._killer = 0
        self._damage = 0
        self._world = 0
        self._fire = 0
        self._hurt = 0
        self._hit = 0

    def attacker(self, attacker, name, damage, zone):
        if not self._attacker.has_key(attacker): self._attacker[attacker] = AttackerInfo(name)
        self._attacker[attacker].hurt(int(damage), int(zone))

    def victim(self, victim, name, damage, zone):
        if not self._victim.has_key(victim): self._victim[victim] = VictimInfo(name)
        self._victim[victim].hurt(int(damage), int(zone))
        self._damage += int(damage)
        self._hurt += 1
        self._hit += 1

    def killed(self, victim, weapon, headshot, distance):
        self._victim[victim]._weapon = weapon
        self._victim[victim]._headshot = headshot
        self._victim[victim]._distance = distance
        self._killed.append(self._victim[victim])

    def killer(self, attacker, name, health, weapon, headshot, distance):
        damage = self._attacker[attacker]
        self._killer = (name, damage._hit, damage._damage, health, weapon, headshot, distance)



#  LANG
def loadString(pathern):
    global language
    language = langlib.Strings(pathern)

def getString(string, userid, options = {}):
    try: lang = langlib.getLangAbbreviation(es.getclientvar(userid, "cl_language"))
    except: lang = langlib.getDefaultLang()
    return language(string, options, lang)



#  EVENT
def unload():
    for menu in popup: popuplib.delete(menu)
    es.doblock("corelib/noisy_off")
    es.unregclientcmd("!hit")
    es.unregsaycmd("!hit")

def init():
    global stats
    loadString(es.getAddonPath("hit_stat") + "/language.ini")
    for menu in popup: popuplib.delete(menu)
    popup.clear()
    stats.clear()
    for player in es.getUseridList():
        stats[str(player)] = PlayerStat(es.getplayername(player))
        settings[str(player)] = [True, 15]

def load():
    es.regclientcmd("!hit", "hit_stat/player_stat", "Say/client command for get stats registered")
    es.regsaycmd("!hit", "hit_stat/player_stat", "Say/client command for get stats registered")
    es.doblock("corelib/noisy_on")
    init()

def es_map_start(event):
    init()

def player_stat():
    userid = es.getcmduserid()
    hsmenu = "hs_popup_%s" % userid
    if popuplib.exists(hsmenu) and settings[str(userid)][0]:
        menu = popuplib.active(userid)["name"]
        if menu in popup: popuplib.close(menu, userid)
        popuplib.send(hsmenu, userid)
    else:
        es.tell(userid, "#multi", getString("cmnd emptie", userid, {"player" : es.getplayername(userid)}))
        stats[str(userid)] = PlayerStat(es.getplayername(userid))
        player_menu(str(userid))

def player_team(event):
    if event["oldteam"] == "0" and not es.isbot(event["userid"]):
        es.tell(event["userid"], "#multi", getString("cmnd advert", event["userid"]))
        settings[event["userid"]] = [True, 15]

def player_spawn(event):
    stats[event["userid"]] = PlayerStat(event["es_username"])

def player_hurt(event):
    if not int(event["attacker"]): stats[event["userid"]]._world += int(event["dmg_health"])
    else:
        stats[event["userid"]].attacker(event["attacker"], event["es_attackername"], event["dmg_health"], event["hitgroup"])
        stats[event["attacker"]].victim(event["userid"], event["es_username"], event["dmg_health"], event["hitgroup"])

def player_death(event):
    distance = "%0.2f" % (vecmath.distance(es.getplayerlocation(event["userid"]), es.getplayerlocation(event["attacker"])) * 0.0254)
    stats[event["userid"]].killer(event["attacker"], event["es_attackername"], event["es_attackerhealth"], event["weapon"], event["headshot"], distance)
    stats[event["attacker"]].killed(event["userid"], event["weapon"], event["headshot"], distance)
    if not es.isbot(event["userid"]): player_menu(event["userid"])

def round_end(event):
    for player in [str(userid) for userid in es.getUseridList() if not es.getplayerprop(userid, "CBasePlayer.pl.deadflag") and stats.has_key(str(userid))]:
        if not es.isbot(player) and settings[player][0]: player_menu(player)

def weapon_fire(event):
    stats[event["userid"]]._fire += 1



#  MENU
def total_page(item, choice = 7):
    if item < 2: page = 1
    else:
        page = item / choice
        if item % choice > 1: page += 1
    return page

def items_page(index, page, item, choice = 7):
    if index < page: element = choice
    else: element = item - (index - 1) * choice
    return element

def player_menu(userid):
    statistic = stats[userid]
    menu = popuplib.active(userid)["name"]
    if menu in popup: popuplib.close(menu, userid)

    name = "hs_popup_%s" % userid
    popup.add(name)
    menu = popuplib.create(name)
    menu.timeout("view", settings[userid][1])
    menu.addline(getString("menu stat", userid))
    menu.addline(" ")

    if not statistic._attacker: menu.addline("1. %s" % getString("menu receveid emptie", userid))
    else:
        categorie_menu(userid, "receveid", statistic._attacker)
        menu.addline("->1. %s" % getString("menu receveid", userid))
        menu.submenu(1, "hs_receveid_%s_1" % userid)

    if not statistic._victim: menu.addline("2. %s" % getString("menu given emptie", userid))
    else:
        categorie_menu(userid, "given", statistic._victim)
        menu.addline("->2. %s" % getString("menu given", userid))
        menu.submenu(2, "hs_given_%s_1" % userid)

    if not statistic._killed: menu.addline("3. %s" % getString("menu killed emptie", userid))
    else:
        categorie_menu(userid, "killed", statistic._killed)
        menu.addline("->3. %s" % getString("menu killed", userid))
        menu.submenu(3, "hs_killed_%s_1" % userid)

    if not statistic._killer: menu.addline("4. %s" % getString("menu killer emptie", userid))
    else:
        killer_menu(userid, "killer", statistic._killer)
        menu.addline("->4. %s" % getString("menu killer", userid, {"player" : statistic._killer[0]}))
        menu.submenu(4, "hs_killer_%s_%s" % (userid, statistic._killer[0]))

    menu.addline("->5. %s" % getString("menu global", userid))
    global_menu(userid, statistic)
    menu.submenu(5, "hs_global_%s" % userid)
    menu.addline("->6. %s" % getString("menu config", userid))
    config_menu(userid, statistic)
    menu.submenu(6, "hs_config_%s" % userid)
    menu.addline(" ")
    menu.addline("0. %s" % getString("menu exit", userid))
    menu.send(userid)


def categorie_menu(userid, categorie, statistic):
    count = len(statistic)
    total = total_page(count)
    page = 0

    while page < total:
        page += 1
        choice = 0
        items = items_page(page, total, count)

        name = "hs_%s_%s_%s" % (categorie, userid, page)
        popup.add(name)
        menu = popuplib.create(name)
        menu.timeout("view", settings[userid][1])
        menu.addline("%s     (%s/%s)" % (getString("menu %s title" % categorie, userid), page, total))
        menu.addline(" ")

        while choice < items:
            index = (page - 1) * 7 + choice
            choice += 1

            if categorie in "receveidgiven":
                player = statistic.keys()
                info = statistic[player[index]]
                damage_menu(userid, categorie, info, page)
                menu.addline("->%s. %s" % (choice, info._name))
                menu.submenu(choice, "hs_%s_%s_%s" % (categorie, userid, info._name))

            elif categorie == "killed":
                info = statistic[index]
                killed_menu(userid, categorie, info, page)
                menu.addline("->%s. %s" % (choice, info._name))
                menu.submenu(choice, "hs_%s_%s_%s" % (categorie, userid, info._name))

        menu.addline(" ")
        if page < total:
            menu.addline("8. %s" % getString("menu next", userid))
            menu.submenu(8, "hs_%s_%s_%s" % (categorie, userid, page + 1))
        if page == 1:
            menu.addline("9. %s" % getString("menu back", userid))
            menu.submenu(9, "hs_popup_%s" % userid)
        else:
            menu.addline("9. %s" % getString("menu back", userid))
            menu.submenu(9, "hs_%s_%s_%s" % (categorie, userid, page - 1))
        menu.addline("0. %s" % getString("menu exit", userid))

def damage_menu(userid, categorie, player, page):
    name = "hs_%s_%s_%s" % (categorie, userid, player._name)
    popup.add(name)
    menu = popuplib.create(name)
    menu.timeout("view", settings[userid][1])
    menu.addline(getString("menu %s player" % categorie, userid, {"player" : player._name}))
    menu.addline(" ")
    menu.addline(getString("hit", userid, {"hit" : player._hit}))
    menu.addline(getString("damage", userid, {"healthpoint" : player._damage}))
    group = 0
    menu.addline(" ")
    while group < 8:
        if player._zone[group][0]: menu.addline(getString("zone %s" % group, userid, {"healthpoint" : player._zone[group][0], "hit" : player._zone[group][1]}))
        group += 1
    menu.addline(" ")
    menu.addline("9. %s" % getString("menu back", userid))
    menu.submenu(9, "hs_%s_%s_%s" % (categorie, userid, page))
    menu.addline("0. %s" % getString("menu exit", userid))

def killed_menu(userid, categorie, player, page):
    name = "hs_%s_%s_%s" % (categorie, userid, player._name)
    popup.add(name)
    menu = popuplib.create(name)
    menu.timeout("view", settings[userid][1])
    menu.addline(getString("menu %s player" % categorie, userid, {"player" : player._name}))
    menu.addline(" ")
    menu.addline(getString("hit", userid, {"hit" : player._hit}))
    menu.addline(getString("damage", userid, {"healthpoint" : player._damage}))
    menu.addline(" ")
    menu.addline(getString("weapon", userid, {"weapon" : player._weapon}))
    menu.addline(getString("headshot", userid, {"headshot" : player._headshot}))
    menu.addline(getString("distance", userid, {"distance" : player._distance}))
    menu.addline(" ")
    menu.addline("9. %s" % getString("menu back", userid))
    menu.submenu(9, "hs_%s_%s_%s" % (categorie, userid, page))
    menu.addline("0. %s" % getString("menu exit", userid))

def killer_menu(userid, categorie, player):
    name = "hs_%s_%s_%s" % (categorie, userid, player[0])
    popup.add(name)
    menu = popuplib.create(name)
    menu.timeout("view", settings[userid][1])
    menu.addline(getString("menu %s player" % categorie, userid, {"player" : player[0]}))
    menu.addline(" ")
    menu.addline(getString("hit", userid, {"hit" : player[1]}))
    menu.addline(getString("damage", userid, {"healthpoint" : player[2]}))
    menu.addline(getString("remaining", userid, {"healthpoint" : player[3]}))
    menu.addline(" ")
    menu.addline(getString("weapon", userid, {"weapon" : player[4]}))
    menu.addline(getString("headshot", userid, {"headshot" : player[5]}))
    menu.addline(getString("distance", userid, {"distance" : player[6]}))
    menu.addline(" ")
    menu.addline("9. %s" % getString("menu back", userid))
    menu.submenu(9, "hs_popup_%s" % userid)
    menu.addline("0. %s" % getString("menu exit", userid))

def global_menu(userid, statistic):
    name = "hs_global_%s" % userid
    popup.add(name)
    menu = popuplib.create(name)
    menu.timeout("view", settings[userid][1])
    menu.addline(getString("menu global player", userid, {"player" : statistic._name}))
    menu.addline(" ")
    menu.addline(getString("global hit", userid, {"hit" : statistic._hit}))
    menu.addline(getString("global damage", userid, {"healthpoint" : statistic._damage}))
    menu.addline(getString("global world", userid, {"healthpoint" : statistic._world}))
    if statistic._hurt and statistic._fire:
        precision = "%0.2f" % (float(statistic._hurt) / statistic._fire * 100)
        if float(precision) >= 100.: precision = 100
        menu.addline(getString("global precision", userid, {"percent" : precision, "hit" : statistic._fire, "hurt" : statistic._hurt}))
    else: menu.addline(getString("global precision", userid, {"percent" : "100", "hit" : statistic._fire, "hurt" : statistic._hurt}))
    menu.addline(" ")
    menu.addline("9. %s" % getString("menu back", userid))
    menu.submenu(9, "hs_popup_%s" % userid)
    menu.addline("0. %s" % getString("menu exit", userid))


# CONFIG
def config_menu(userid, player):
    name = "hs_config_%s" % userid
    popup.add(name)
    menu = popuplib.create(name)
    menu.addline(getString("menu config player", userid, {"player" : player._name}))
    menu.addline(" ")
    menu.addline(" ")
    menu.addline(" ")
    menu.addline(" ")
    menu.addline("9. %s" % getString("menu back", userid))
    menu.submenu(9, "hs_popup_%s" % userid)
    menu.addline("0. %s" % getString("menu exit", userid))
    menu.menuselect = config_user
    config_update(userid, menu)

def config_user(userid, choice, popup):
    if choice == 1:
        config = settings[str(userid)]
        if config[0]: config[0] = False
        else: config[0] = True
        menu = popuplib.find(popup)
        config_update(userid, menu)
        menu.send(userid)
    elif choice == 2:
        config = settings[str(userid)]
        if config[1] == 60: config[1] = 0
        elif not config[1]: config[1] = 15
        else: config[1] *= 2
        menu = popuplib.find(popup)
        config_update(userid, menu)
        menu.send(userid)
        

def config_update(userid, menu):
    config = settings[str(userid)]
    if config[0]: menu.modline(3, "->1. %s" % getString("menu config stat on", userid))
    else: menu.modline(3, "->1. %s" % getString("menu config stat off", userid))
    menu.modline(4, "->2. %s" % getString("menu config vgui %s" % config[1], userid))
